Package tigase.server.xmppsession

# Class SessionManager.SessionCloseProc

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.server.xmppsession.SessionManager.SessionCloseProc

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

Enclosing class:
  SessionManager

@Bean(name="session-close", parent=SessionManager.class, active=true) public static class SessionManager.SessionCloseProc extends XMPPProcessor implements XMPPProcessorIfc

- ## Field Summary

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SessionCloseProc()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `concurrentQueuesNo()`
  Methods returns a preferable number of threads/packets queues for the plugin.
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, getComponentInfo, getStatistics, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

- ## Constructor Details

  - ### SessionCloseProc

    public SessionCloseProc()

- ## Method Details

  - ### concurrentQueuesNo

    public int concurrentQueuesNo()
    Description copied from interface: `XMPPImplIfc`
    Methods returns a preferable number of threads/packets queues for the plugin. This number can be overwritten through configuration settings, however, a default value should be reasonably good for most standard installations. It is recommended to assign at least as much as twice a number of CPUs cores for I/O bound processing and number a number equal to CPUs cores for fast processing not slowed down by any I/O.
    Specified by:
      `concurrentQueuesNo` in interface `XMPPImplIfc`
    Overrides:
      `concurrentQueuesNo` in class `XMPPProcessor`
    Returns:
      an integer preferred number of processing threads for the plugin.

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Returns:
      a `String` value

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`